// You have generated a new plugin project without specifying the `--platforms`
// flag. A plugin project with no platform support was generated. To add a
// platform, run `flutter create -t plugin --platforms <platforms> .` under the
// same directory. You can also find a detailed instruction on how to add
// platforms in the `pubspec.yaml` at
// https://flutter.dev/docs/development/packages-and-plugins/developing-packages#plugin-platforms.

library aargul_crud;

import 'dart:async';
import 'dart:math';

import 'package:aargul_core/aargul_core.dart';
import 'package:data_table_2/data_table_2.dart';
import 'package:flutter/material.dart' as material;
import 'package:flutter/services.dart';
import 'package:simple_grid/simple_grid.dart';
import 'package:events_emitter/events_emitter.dart';
import 'package:visibility_detector/visibility_detector.dart';

import 'package:flutter_map/flutter_map.dart';
import 'package:flutter_map_animations/flutter_map_animations.dart';
import 'package:flutter_map_radius_cluster/flutter_map_radius_cluster.dart';
import 'package:latlong2/latlong.dart';

export 'package:flutter_map/flutter_map.dart';
export 'package:latlong2/latlong.dart';

part 'parts/utils.dart';
part 'parts/vars.dart';
part 'parts/enums.dart';
part 'parts/field.dart';
part 'parts/options.dart';
part 'parts/store.dart';
part 'parts/manager.dart';
part 'parts/manager_form.dart';
part 'parts/manager_table.dart';
part 'parts/manager_grid.dart';
part 'parts/manager_map.dart';
part 'parts/field_action.dart';
part 'parts/action.dart';
part 'parts/defaults.dart';

class AargulCrud extends AargulModule {
  @override
  void initModule(AargulContext aargulContext) async {
    _setDefaultAargulCrudFields();
    await register(AargulCrudAction());
    aargulContext.next();
  }
}
