part of aargul_crud;

extension ExtensionAargulCrudManagerForm on AargulCrudManager {
  SpGridItem _formItem(AargulCrudField field, Widget child) {
    return SpGridItem(
      xl: field.xl != null ? (field.xl!.index + 1) : null,
      lg: field.lg != null ? (field.lg!.index + 1) : null,
      md: field.md != null ? (field.md!.index + 1) : null,
      sm: field.sm != null ? (field.sm!.index + 1) : null,
      xs: field.xs != null ? (field.xs!.index + 1) : 12,
      child: child,
    );
  }

  Widget form(
      {Map<String, dynamic>? values,
      bool? edit,
      BoxDecoration? fieldDecoration,
      TextStyle? labelStyle,
      EdgeInsetsGeometry? padding,
      EdgeInsetsGeometry? margin,
      double spacing = 10,
      double runSpacing = 10}) {
    bool update = edit ?? values != null;
    Map<String, dynamic> values0 = {};
    return Builder(
      builder: (context) => Form(
          child: SpGrid(
        margin: margin,
        padding: padding,
        spacing: spacing,
        runSpacing: runSpacing,
        width: MediaQuery.of(context).size.width,
        children: options.fields
            .map((fieldName, field) {
              field._fields.clear();
              field._fields.addAll(options
                  .fields); // assign form fields, accessible via field.formFiel(key)
              if (values != null && values.containsKey(fieldName)) {
                field._value = values[fieldName];
                values0[fieldName] = field._value;
              }

              var widget = AargulCrudManager._typeBuilder[field.type] != null
                  ? AargulCrudManager._typeBuilder[field.type]!(
                      fieldName, field, fieldDecoration, labelStyle)
                  : AargulCrudManager
                          ._typeBuilder[AargulCrudFieldType.input.name]!(
                      fieldName, field, fieldDecoration, labelStyle);
              if (field.editable == false || widget == null) {
                return MapEntry<String, dynamic>(fieldName, null);
              }
              var item = _formItem(field, widget);
              if (field.hasInput) values0[fieldName] = field.value;
              field.on(_fieldUpdatedEvent, (v) {
                if (field.hasInput) {
                  values0[fieldName] = field.value;
                } else {
                  values0.remove(fieldName);
                }
              });
              field.on("submit", (v) {
                ((update ? options.update : options.create) ??
                        ((value) async {}))
                    .call(values0)
                    .then((value) {
                  field.emit("submited", value);
                });
              });
              return MapEntry<String, SpGridItem>(fieldName, item);
            })
            .values
            .whereType<SpGridItem>()
            .toList(),
      )),
    );
  }
}
